﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;

namespace CompanySLApp
{
    public partial class Page : UserControl
    {
        private static Page _page;

        public Page()
        {
            InitializeComponent();

        }

        public static Grid RootGrid
        {
            get
            {
                return _page.LayoutRoot;
            }
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            _page = this;
            //(this.Resources["OpenSotryBoard"] as Storyboard).Begin();
        }

        private void ViewListButton_Click(object sender, RoutedEventArgs e)
        {
            this.Placeholder.Children.Clear();
            this.Placeholder.Children.Add(new CompaniesList());
        }

        public static void ShowLoadingLabel()
        {
            if (_page != null)
                _page.BusyImage.Visibility = Visibility.Visible;
        }
        public static void HideLoadingLabel()
        {
            if (_page != null)
                _page.BusyImage.Visibility = Visibility.Collapsed;
        }
        public static void ShowGrid()
        {
            ShowLoadingLabel();
            _page.Placeholder.Children.Clear();
            _page.Placeholder.Children.Add(new CompaniesList());
        }

        public static void ShowCompanyControl()
        {
            CompanyServiceReference.Companies newCompany = new CompanySLApp.CompanyServiceReference.Companies();
            newCompany.Persons = new System.Collections.ObjectModel.ObservableCollection<CompanySLApp.CompanyServiceReference.Persons>();
            _page.Placeholder.Children.Clear();
            EditCompany newControl = new EditCompany(newCompany);
            HideLoadingLabel();
            _page.Placeholder.Children.Add(newControl);
        }

        public static void ShowCompanyControl(int companyId)
        {
            ShowLoadingLabel();
            _page.Placeholder.Children.Clear();
            CompanyServiceReference.CompanyServiceClient client = new CompanyServiceReference.CompanyServiceClient();
            client.GetCompanyByIdCompleted += new EventHandler<CompanySLApp.CompanyServiceReference.GetCompanyByIdCompletedEventArgs>(_page.client_GetCompanyByIdCompleted);
            client.GetCompanyByIdAsync(companyId);
        }

        private void client_GetCompanyByIdCompleted(object sender, CompanySLApp.CompanyServiceReference.GetCompanyByIdCompletedEventArgs e)
        {
            this.Placeholder.Children.Clear();
            EditCompany newControl = new EditCompany(e.Result);
            HideLoadingLabel();
            this.Placeholder.Children.Add(newControl);
        }

    }
}
